package gsample;

import java.io.Serializable;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * MemberBean.java
 * <pre>
 *
 * </pre>
 * $Id$
 * @author Takayosi_sato
 *
 */
public class MemberBean implements Serializable {

	public static final String SESSION_KEY = "memberBean";

	// properties
	private String name = "";
	private String age = "";

	private List errorMessageList = new ArrayList();

	/**
	 * Constructor for MemberBean.
	 * <pre>
	 *
	 * </pre>
	 *
	 */
	public MemberBean() {
	}

	/**
	 * <pre>
	 * ͂擾Ao^sB
	 * ͂ɕsꍇ́AG[bZ[W𐶐Ainput.jspɖ߂B
	 * </pre>
	 * @param request
	 */
	public void accept(
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {

		this.name = getParam(request, "name");
		this.age = getParam(request, "age");
		Connection conn = null;
		try {
			conn = ConnectionFactory.getConnection();
			if (paramValidate()) {
				this.doRegist(conn);
			}
			else {
				// return to input.jsp
				RequestDispatcher dispatcher =
					request.getRequestDispatcher("/input.jsp");
				dispatcher.forward(request, response);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
		finally {
			ConnectionFactory.freeConnection(conn);
		}
	}

	// -----------------------------------------------------------------------
	// checker
	// -----------------------------------------------------------------------

	/**
	 * <pre>
	 * ̓`FbN
	 * </pre>
	 * @return
	 */
	private boolean paramValidate() {
		errorMessageList = new ArrayList();
		Parameter p = null;

		// ̃`FbN
		p = new Parameter(this.name);
		// 󔒕s
		p.addChecker(new NullChecker(""));
		// 20܂
		p.addChecker(new LengthChecker("", 20));
		if(!p.executeCheck()){
			errorMessageList.add(p.getErrorMessage());
		}

		// Ñ`FbN
		p = new Parameter(this.age);
		// 󔒕s
		p.addChecker(new NullChecker("N"));
		// ̂݋
		p.addChecker(new NumericChecker("N"));
		if(!p.executeCheck()){
			errorMessageList.add(p.getErrorMessage());
		}

		// ʊmF
		if(errorMessageList.size() == 0){
			// G[OK
			return true;
		}
		else{
			// G[bZ[W݂ꍇ́AfalseB
			return false;
		}
	}

	/**
	 * <pre>
	 * \pG[bZ[W擾B
	 * </pre>
	 * @return String - G[bZ[W\
	 */
	public String getErrorMessageHtml(){
		if(errorMessageList.size() == 0){
			return "";
		}
		StringBuffer buf = new StringBuffer();
		buf.append("<ul>\n");
		for (Iterator iter = errorMessageList.iterator(); iter.hasNext(); ) {
			String  element = (String )iter.next();
			buf.append("<li>");
			buf.append(element);
			buf.append("</li>\n");
		}
		buf.append("</ul>\n");
		return new String(buf);
	}


	// -----------------------------------------------------------------------
	// db
	// -----------------------------------------------------------------------
	/**
	 * <pre>
	 * o^s
	 * </pre>
	 * @param conn
	 * @throws SQLException
	 */
	private void doRegist(Connection conn) throws SQLException {

		String sql = "insert into member values (?, ?)";
		PreparedStatement pst = null;
		try {
			conn.setAutoCommit(false);
			pst = conn.prepareStatement(sql);
			pst.setString(1, name);
			pst.setString(2, age);
			pst.executeUpdate();
			conn.commit();
		}
		catch (SQLException e) {
			e.printStackTrace();
			try {
				conn.rollback();
			}
			catch (Exception e2) {
				e2.printStackTrace();
			}
			throw e;
		}
		finally {
			if (pst != null) {
				pst.close();
				pst = null;
			}
		}
	}

	/**
	 * <pre>
	 * o^ς݈ꗗ擾
	 * </pre>
	 * @return
	 * @throws SQLException
	 */
	public String getMemberList() throws SQLException{
		String sql = "select name, age from member";
		Connection conn = null;
		PreparedStatement pst = null;
		ResultSet rs = null;
		StringBuffer buf = new StringBuffer();
		try {
			conn = ConnectionFactory.getConnection();
			pst = conn.prepareStatement(sql);
			rs = pst.executeQuery();
			while(rs.next()){
				buf.append(this.replaceTagToEntity(rs.getString("name")));
				buf.append(" / ");
				buf.append(rs.getString("age"));
				buf.append("<br />");
			}
		}
		catch (SQLException e) {
			e.printStackTrace();
			throw e;
		}
		finally {
			ConnectionFactory.freeConnection(conn);
			if (pst != null) {
				pst.close();
				pst = null;
			}
			if(rs != null){
				rs.close();
				rs = null;
			}
		}
		String str = new String(buf);
		if(str.length() <= 0){
			str = "f[^܂";
		}
		return str;
	}


	// -----------------------------------------------------------------------
	// util
	// -----------------------------------------------------------------------
	/**
	 * <pre>
	 *
	 * </pre>
	 * @param request
	 * @param key
	 * @return value
	 */
	private String getParam(HttpServletRequest request, String key) {
		String value = request.getParameter(key);
		/*
		try {
			value = new String(value.getBytes("8859_1"), "Windows-31J");
		}
		catch (UnsupportedEncodingException ex) {
			ex.printStackTrace();
		}*/
		return value;
	}

	/**
	 * <pre>
	 * HTML̎QƒuB
	 * </pre>
	 * @param str
	 * @return
	 */
	private String replaceTagToEntity(String str) {
		str = replace(str, "&", "&amp;");
		str = replace(str, "\"", "&quot;");
		str = replace(str, "<", "&lt;");
		str = replace(str, ">", "&gt;");
		return str;
	}

	/**
	 * <pre>
	 * u
	 * </pre>
	 * @param target
	 * @param oldStr
	 * @param newStr
	 * @return
	 */
	private String replace(String target, String oldStr, String newStr) {
		Pattern p = Pattern.compile(oldStr);
		Matcher m = p.matcher(target);
		return m.replaceAll(newStr);
	}




	// -----------------------------------------------------------------------
	// getter, setter
	// -----------------------------------------------------------------------
	/**
	 * <pre>
	 *
	 * </pre>
	 * @return
	 */
	public String getAge() {
		return age;
	}

	/**
	 * <pre>
	 *
	 * </pre>
	 * @return
	 */
	public String getAge_esc() {
		return this.replaceTagToEntity(age);
	}

	/**
	 * <pre>
	 *
	 * </pre>
	 * @return
	 */
	public String getName() {
		return name;
	}

	/**
	 * <pre>
	 *
	 * </pre>
	 * @return
	 */
	public String getName_esc() {
		return this.replaceTagToEntity(name);
	}

	/**
	 * <pre>
	 *
	 * </pre>
	 * @param string
	 */
	public void setAge(String string) {
		age = string;
	}

	/**
	 * <pre>
	 *
	 * </pre>
	 * @param string
	 */
	public void setName(String string) {
		name = string;
	}

}
